package com.zcloud.controller.sms;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.entity.system.Dictionaries;
import com.zcloud.entity.system.Role;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.corp.CorpInfoService;
import com.zcloud.service.sms.SMSManagementService;
import com.zcloud.service.system.DictionariesService;
import com.zcloud.service.system.RoleService;
import com.zcloud.service.system.UsersService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：短信管理
 * 作者：luoxiaobao
 * 时间：2021-01-21
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/smsmanagement")
public class SMSManagementController extends BaseController {

	@Autowired
	private SMSManagementService smsmanagementService;

	@Autowired
	private DictionariesService dictionariesService;

	@Autowired
	private CorpInfoService corpinfoService;

	@Autowired
    private UsersService usersService;
	@Autowired
    private RoleService roleService;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("smsmanagement:add")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "短信管理",instructionsOperate = "短信类型管理",instructionsType = "是否启用状态")
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		if(null!=pd.getString("SMSMANAGEMENT_ID")&&!"".equals(pd.getString("SMSMANAGEMENT_ID"))) {
			PageData spd =	smsmanagementService.findById(pd);
			if(spd!=null) {
				if(spd.getString("ISENABLE").equals("1")) {
					pd.put("ISENABLE", "0");	//操作人
					smsmanagementService.editIsEnable(pd);
					PageData slpd = new PageData();
					slpd.put("ISENABLE", "1");
					slpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
					List<PageData>	varList = smsmanagementService.listAll(slpd);
					if(varList.size()<=0) {
						PageData cpd = new PageData();
						cpd.put("ISRECEIVE", "0");
						cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
						corpinfoService.editIsReceive(cpd);
					}
				}else {
					pd.put("ISENABLE", "1");	//操作人
					smsmanagementService.editIsEnable(pd);
					PageData cpd = new PageData();
					cpd.put("ISRECEIVE", "1");
					cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
					corpinfoService.editIsReceive(cpd);
				}

			}
		}else {
				PageData dpd =dictionariesService.findById(pd);
				pd.put("SMSMANAGEMENT_ID", this.get32UUID());	//主键
				pd.put("SMSNAME", dpd.getString("NAME"));	//操作人
				pd.put("SMSCODE", dpd.getString("BIANMA"));	//操作人
				pd.put("SMSTYPE", dpd.getString("DICTIONARIES_ID"));	//操作人
				pd.put("ISENABLE", "1");	//操作人
				pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//操作人
				pd.put("OPDATE", DateUtil.date2Str(new Date()));	//操作日期
				pd.put("OPUSER", Jurisdiction.getUsername());	//操作人
				pd.put("ISDELETE", "0");	//是否删除
				pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
				pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改日期
				smsmanagementService.save(pd);
				PageData cpd = new PageData();
				cpd.put("ISRECEIVE", "1");
				cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
				corpinfoService.editIsReceive(cpd);
		}

		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param out
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("smsmanagement:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		smsmanagementService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("smsmanagement:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		smsmanagementService.edit(pd);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/editUserName")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "短信管理",instructionsOperate = "短信类型管理",instructionsType = "通过选择用户发送信息")
	public Object editUserName() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		smsmanagementService.editUserName(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("smsmanagement:list")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "短信管理",instructionsOperate = "短信类型管理",instructionsType = "列表")
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("DICTIONARIES_ID", "514042127588463bba0bec45e982d42f");
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		page.setPd(pd);
		List<PageData>	varList = smsmanagementService.list(page);	//列出SMSManagement列表
		PageData cpd = new PageData();
		cpd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		cpd=corpinfoService.findById(cpd);
		if(cpd!=null) {
			map.put("cpd", cpd);
		}

		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}
	@RequestMapping("/userlist")
	@ResponseBody
	@LogAnno(menuType= "综合管理",menuServer= "短信管理",instructionsOperate = "短信类型管理",instructionsType = "配置列表")
	public Object listUsers(Page page)throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();

		/*检索条件*/
		String ROLE_ID = pd.getString("ROLE_ID");						//角色ID
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		String DEPARTMENT_ID = pd.getString("DEPARTMENT_ID");						//关键词检索条件
		if(Tools.notEmpty(DEPARTMENT_ID))pd.put("DEPARTMENT_ID", DEPARTMENT_ID.trim());
		String STARTTIME = pd.getString("STARTTIME");					//开始时间
		String ENDTIME = pd.getString("ENDTIME");						//结束时间
		if(Tools.notEmpty(STARTTIME))pd.put("STARTTIME", STARTTIME+" 00:00:00");
		if(Tools.notEmpty(ENDTIME))pd.put("ENDTIME", ENDTIME+" 00:00:00");
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		pd.put("VIPLEVEL", Jurisdiction.getVIPLEVEL());
		page.setPd(pd);
		List<PageData>	userList = usersService.userlistPage(page);		//列出用户列表
		pd.put("ROLE_ID", "1");
		List<Role> roleList = roleService.listAllRolesByPId(pd);		//列出所有系统用户角色
		PageData spd =	smsmanagementService.findById(pd);
		List<PageData>	checkuserList =new ArrayList<PageData>();
		if(spd!=null) {
			if(null!=spd.getString("ADDRESSEE")&&!"".equals(spd.getString("ADDRESSEE"))) {
				checkuserList =usersService.listUserBYids(spd.getString("ADDRESSEE").split(","));

			}
		}
		map.put("checkuserList", checkuserList);
		map.put("userList", userList);
		map.put("roleList", roleList);
		map.put("ROLE_ID", ROLE_ID);

		map.put("page", page);
		map.put("pd", pd);

		map.put("result", errInfo);
		return map;
	}
	@RequestMapping(value="/checkuserList")
	@ResponseBody
	public Object checkuserList() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		PageData spd =	smsmanagementService.findById(pd);
		List<PageData>	checkuserList =new ArrayList<PageData>();
		if(spd!=null) {
			if(null!=spd.getString("ADDRESSEE")&&!"".equals(spd.getString("ADDRESSEE"))) {
				checkuserList =usersService.listUserBYids(spd.getString("ADDRESSEE").split(","));

			}
		}
		map.put("checkuserList", checkuserList);
		map.put("result", errInfo);
		return map;
	}
	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	// @RequiresPermissions("smsmanagement:edit")
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = smsmanagementService.findById(pd);	//根据ID读取
		List<Dictionaries>	varList = dictionariesService.listSubDictByParentId("514042127588463bba0bec45e982d42f");
		corpinfoService.listAll(pd);
		map.put("pd", pd);
		map.put("pd", varList);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("smsmanagement:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			smsmanagementService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("名称");	//1
		titles.add("编码");	//2
		titles.add("类型");	//3
		titles.add("收信人");	//4
		titles.add("是否启用");	//5
		titles.add("企业ID");	//6
		titles.add("操作日期");	//7
		titles.add("操作人");	//8
		titles.add("是否删除");	//9
		titles.add("修改人");	//10
		titles.add("修改日期");	//11
		dataMap.put("titles", titles);
		List<PageData> varOList = smsmanagementService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("SMSNAME"));	    //1
			vpd.put("var2", varOList.get(i).getString("SMSCODE"));	    //2
			vpd.put("var3", varOList.get(i).getString("SMSTYPE"));	    //3
			vpd.put("var4", varOList.get(i).getString("ADDRESSEE"));	    //4
			vpd.put("var5", varOList.get(i).getString("ISENABLE"));	    //5
			vpd.put("var6", varOList.get(i).getString("CORPINFO_ID"));	    //6
			vpd.put("var7", varOList.get(i).getString("OPDATE"));	    //7
			vpd.put("var8", varOList.get(i).getString("OPUSER"));	    //8
			vpd.put("var9", varOList.get(i).getString("ISDELETE"));	    //9
			vpd.put("var10", varOList.get(i).getString("OPERATOR"));	    //10
			vpd.put("var11", varOList.get(i).getString("OPERATTIME"));	    //11
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
